package com.neusoft.smart.pos.ota.persistent.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class DeviceUpgradeHistoryExample {

	protected String orderByClause;

	protected boolean distinct;

	protected List<Criteria> oredCriteria;

	private Integer offset;

	private Integer limit;

	public DeviceUpgradeHistoryExample() {
		oredCriteria = new ArrayList<Criteria>();
	}

	public String getOrderByClause() {
		return orderByClause;
	}

	public void setOrderByClause(String orderByClause) {
		this.orderByClause = orderByClause;
	}

	public boolean isDistinct() {
		return distinct;
	}

	public void setDistinct(boolean distinct) {
		this.distinct = distinct;
	}

	public List<Criteria> getOredCriteria() {
		return oredCriteria;
	}

	public void or(Criteria criteria) {
		oredCriteria.add(criteria);
	}

	public Criteria or() {
		Criteria criteria = createCriteriaInternal();
		oredCriteria.add(criteria);
		return criteria;
	}

	public Criteria createCriteria() {
		Criteria criteria = createCriteriaInternal();
		if (oredCriteria.size() == 0) {
			oredCriteria.add(criteria);
		}
		return criteria;
	}

	protected Criteria createCriteriaInternal() {
		Criteria criteria = new Criteria();
		return criteria;
	}

	public void clear() {
		oredCriteria.clear();
		orderByClause = null;
		distinct = false;
		this.offset = null;
		this.limit = null;
	}

	public Integer getOffset() {
		return this.offset;
	}

	public void setOffset(Integer offset) {
		this.offset = offset;
	}

	public Integer getLimit() {
		return this.limit;
	}

	public void setLimit(Integer limit) {
		this.limit = limit;
	}

	public DeviceUpgradeHistoryExample page(int offset, int limit) {
		this.offset = offset;
		this.limit = limit;
		return this;
	}

	protected abstract static class GeneratedCriteria {

		protected List<Criterion> criteria;

		protected GeneratedCriteria() {
			super();
			criteria = new ArrayList<Criterion>();
		}

		public boolean isValid() {
			return criteria.size() > 0;
		}

		public List<Criterion> getAllCriteria() {
			return criteria;
		}

		public List<Criterion> getCriteria() {
			return criteria;
		}

		protected void addCriterion(String condition) {
			if (condition == null) {
				throw new RuntimeException("Value for condition cannot be null");
			}
			criteria.add(new Criterion(condition));
		}

		protected void addCriterion(String condition, Object value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value));
		}

		protected void addCriterion(String condition, Object value1, Object value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value1, value2));
		}

		public Criteria andIdIsNull() {
			addCriterion("id is null");
			return (Criteria) this;
		}

		public Criteria andIdIsNotNull() {
			addCriterion("id is not null");
			return (Criteria) this;
		}

		public Criteria andIdEqualTo(Integer value) {
			addCriterion("id =", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotEqualTo(Integer value) {
			addCriterion("id <>", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdGreaterThan(Integer value) {
			addCriterion("id >", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("id >=", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdLessThan(Integer value) {
			addCriterion("id <", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdLessThanOrEqualTo(Integer value) {
			addCriterion("id <=", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdIn(List<Integer> values) {
			addCriterion("id in", values, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotIn(List<Integer> values) {
			addCriterion("id not in", values, "id");
			return (Criteria) this;
		}

		public Criteria andIdBetween(Integer value1, Integer value2) {
			addCriterion("id between", value1, value2, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotBetween(Integer value1, Integer value2) {
			addCriterion("id not between", value1, value2, "id");
			return (Criteria) this;
		}

		public Criteria andDeviceIdIsNull() {
			addCriterion("device_id is null");
			return (Criteria) this;
		}

		public Criteria andDeviceIdIsNotNull() {
			addCriterion("device_id is not null");
			return (Criteria) this;
		}

		public Criteria andDeviceIdEqualTo(Integer value) {
			addCriterion("device_id =", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdNotEqualTo(Integer value) {
			addCriterion("device_id <>", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdGreaterThan(Integer value) {
			addCriterion("device_id >", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("device_id >=", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdLessThan(Integer value) {
			addCriterion("device_id <", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdLessThanOrEqualTo(Integer value) {
			addCriterion("device_id <=", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdIn(List<Integer> values) {
			addCriterion("device_id in", values, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdNotIn(List<Integer> values) {
			addCriterion("device_id not in", values, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdBetween(Integer value1, Integer value2) {
			addCriterion("device_id between", value1, value2, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdNotBetween(Integer value1, Integer value2) {
			addCriterion("device_id not between", value1, value2, "deviceId");
			return (Criteria) this;
		}

		public Criteria andPrevVersionIsNull() {
			addCriterion("prev_version is null");
			return (Criteria) this;
		}

		public Criteria andPrevVersionIsNotNull() {
			addCriterion("prev_version is not null");
			return (Criteria) this;
		}

		public Criteria andPrevVersionEqualTo(String value) {
			addCriterion("prev_version =", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionNotEqualTo(String value) {
			addCriterion("prev_version <>", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionGreaterThan(String value) {
			addCriterion("prev_version >", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionGreaterThanOrEqualTo(String value) {
			addCriterion("prev_version >=", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionLessThan(String value) {
			addCriterion("prev_version <", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionLessThanOrEqualTo(String value) {
			addCriterion("prev_version <=", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionLike(String value) {
			addCriterion("prev_version like", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionNotLike(String value) {
			addCriterion("prev_version not like", value, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionIn(List<String> values) {
			addCriterion("prev_version in", values, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionNotIn(List<String> values) {
			addCriterion("prev_version not in", values, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionBetween(String value1, String value2) {
			addCriterion("prev_version between", value1, value2, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andPrevVersionNotBetween(String value1, String value2) {
			addCriterion("prev_version not between", value1, value2, "prevVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionIsNull() {
			addCriterion("cur_version is null");
			return (Criteria) this;
		}

		public Criteria andCurVersionIsNotNull() {
			addCriterion("cur_version is not null");
			return (Criteria) this;
		}

		public Criteria andCurVersionEqualTo(String value) {
			addCriterion("cur_version =", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionNotEqualTo(String value) {
			addCriterion("cur_version <>", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionGreaterThan(String value) {
			addCriterion("cur_version >", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionGreaterThanOrEqualTo(String value) {
			addCriterion("cur_version >=", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionLessThan(String value) {
			addCriterion("cur_version <", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionLessThanOrEqualTo(String value) {
			addCriterion("cur_version <=", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionLike(String value) {
			addCriterion("cur_version like", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionNotLike(String value) {
			addCriterion("cur_version not like", value, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionIn(List<String> values) {
			addCriterion("cur_version in", values, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionNotIn(List<String> values) {
			addCriterion("cur_version not in", values, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionBetween(String value1, String value2) {
			addCriterion("cur_version between", value1, value2, "curVersion");
			return (Criteria) this;
		}

		public Criteria andCurVersionNotBetween(String value1, String value2) {
			addCriterion("cur_version not between", value1, value2, "curVersion");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIsNull() {
			addCriterion("update_time is null");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIsNotNull() {
			addCriterion("update_time is not null");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeEqualTo(Date value) {
			addCriterion("update_time =", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotEqualTo(Date value) {
			addCriterion("update_time <>", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeGreaterThan(Date value) {
			addCriterion("update_time >", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
			addCriterion("update_time >=", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeLessThan(Date value) {
			addCriterion("update_time <", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
			addCriterion("update_time <=", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIn(List<Date> values) {
			addCriterion("update_time in", values, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotIn(List<Date> values) {
			addCriterion("update_time not in", values, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeBetween(Date value1, Date value2) {
			addCriterion("update_time between", value1, value2, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
			addCriterion("update_time not between", value1, value2, "updateTime");
			return (Criteria) this;
		}
	}

	public static class Criteria extends GeneratedCriteria {

		protected Criteria() {
			super();
		}
	}

	public static class Criterion {

		private String condition;

		private Object value;

		private Object secondValue;

		private boolean noValue;

		private boolean singleValue;

		private boolean betweenValue;

		private boolean listValue;

		private String typeHandler;

		protected Criterion(String condition) {
			super();
			this.condition = condition;
			this.typeHandler = null;
			this.noValue = true;
		}

		protected Criterion(String condition, Object value, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.typeHandler = typeHandler;
			if (value instanceof List<?>) {
				this.listValue = true;
			} else {
				this.singleValue = true;
			}
		}

		protected Criterion(String condition, Object value) {
			this(condition, value, null);
		}

		protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.secondValue = secondValue;
			this.typeHandler = typeHandler;
			this.betweenValue = true;
		}

		protected Criterion(String condition, Object value, Object secondValue) {
			this(condition, value, secondValue, null);
		}

		public String getCondition() {
			return condition;
		}

		public Object getValue() {
			return value;
		}

		public Object getSecondValue() {
			return secondValue;
		}

		public boolean isNoValue() {
			return noValue;
		}

		public boolean isSingleValue() {
			return singleValue;
		}

		public boolean isBetweenValue() {
			return betweenValue;
		}

		public boolean isListValue() {
			return listValue;
		}

		public String getTypeHandler() {
			return typeHandler;
		}
	}
}